/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package telainicial;

import JPlay.Keyboard;
import JPlay.Sound;
import JPlay.Sprite;
import JPlay.Window;


/**
 * @author Gefersom Cardoso Lima
 * Universidade Federal Fluminense - UFF - Brasil - 2010
 * Ciência da Computação
 */

public class TelaInicial
{
        Window window;
        Sprite backGround;
        Keyboard keyboard;
        int opcaoEscolhida = 0;
        Sound musica;

        public TelaInicial()
        {
                carregarObjetos();
                loop();
                descarregarObjetos();
        }

        private void carregarObjetos()
        {
                //Cria uma janela com dimensão de 800 x 600.
                window = new Window(800, 600);

                //Muda a imagem do cursor do mouse.
                window.setCursor( window.createCustomCursor("mouse.png") );

                //Carrega o sprite a ser usado, o valor 3 corresponde ao número de frames usados.
                backGround = new Sprite("telaInicial.png", 3);

                //Captura uma instância de teclado presetente pela janela que criamos.
                keyboard = window.getKeyboard();

                //Como as teclas padrões do teclado, up, down, left, right
                //são adiconadas com o comportamento Keyboard.DETECT_EVERY_PRESS,
                //mudamos o coportamento para DETECT_INITIAL_PRESS_ONLY. Para entender
                //o que aconteceria sem não fizessemos isso, apague os comandos abaixo e
                //execute o jogo:
                keyboard.setBehavior(Keyboard.UP_KEY,   Keyboard.DETECT_INITIAL_PRESS_ONLY);
                keyboard.setBehavior(Keyboard.DOWN_KEY, Keyboard.DETECT_INITIAL_PRESS_ONLY);

                musica = new Sound("Megaman - Mega Man X Theme.wav");
                musica.setRepeat(true);//faz a música se repetir continuamente.
        }
        
        private void desenhar()
        {
                //Desenha a imagem usada como fundo da tela.
                backGround.draw();

                //Mostra as atualizações - esse método não pode faltar e tem 
                //que ser o último a ser chamado.
                window.display();        
        }
        
        //Escolha de opções do menu...
        private void atualizacoes()
        {                

                boolean escolheuUmaOpcao = true;

                //Se a tecla foi pressionada...
                if ( keyboard.keyDown(Keyboard.UP_KEY) )
                {
                        //O if serve para não deixar que a opção seja menor que zero.
                        if (opcaoEscolhida > 0)                        
                            opcaoEscolhida--;                        
                }
                else
                {
                        //Se a tecla para baixo foi pressionada...
                        if ( keyboard.keyDown(Keyboard.DOWN_KEY) )
                        {
                            //O if serve para não deixar que a opção seja maior que dois.
                            if (opcaoEscolhida < 2)                            
                                opcaoEscolhida++;                            
                        }
                        else
                        {
                            escolheuUmaOpcao = false;
                        }
                }

                if (escolheuUmaOpcao)
                {
                    new Sound("som.wav").play();
                }

                //Seta a opção do menu escolhida pelo usuário.
                backGround.setCurrFrame(opcaoEscolhida);
        }
        
        private void descarregarObjetos()
        {                        
                window.exit();
                window = null;
                backGround = null;
                keyboard = null;
        }


        private void loop()
        {
                musica.play();
                boolean sair = false;
                do
                {
                        desenhar();
                        atualizacoes();

                        //Se apertar a tecla ESC, sai da tela inicial.
                        if (keyboard.keyDown(Keyboard.ESCAPE_KEY))
                            sair = true;
                        
                }while(sair == false);
        }
}
